scriptname SSOFillAliases extends quest

referencealias property StatueOfMara auto
quest property SSODialogue auto

globalvariable property SSOEggFactoryFound auto
globalvariable property SSOChildFound auto

int Function IsChildRace(Race ThisRace)
	string RaceName = ThisRace.GetName()
	int IsChild = 0
	
	if(StringUtil.Find(RaceName, "Child") != -1)
		IsChild = 1
	elseif(StringUtil.Find(RaceName, "Little") != -1)
		IsChild = 1
	elseif(StringUtil.Find(RaceName, "117") != -1)
		IsChild = 1
	elseif(StringUtil.Find(RaceName, "Enfant") != -1)
		IsChild = 1
	elseif(StringUtil.Find(RaceName, "Elin") != -1)
		IsChild = 1
	elseif(StringUtil.Find(RaceName, "Young") != -1)
		IsChild = 1
	elseif(StringUtil.Find(RaceName, "Monli") != -1)
		IsChild = 1
	endif
	
	return IsChild
EndFunction

Event OnInit()
	registerforsingleupdate(0.5)
    if(Game.GetFormFromFile(0x12C8, "EggFactory.esp") != none)
        SSOEggFactoryFound.SetValue(1)
		debug.trace("SSO detected Egg Factory installed.")
    endif
    
EndEvent

Event OnUpdate()
	;debug.trace("SSO alias filler running!")
	quest chargenquest = Game.GetFormFromFile(0x000DAF, "Alternate Start - Live Another Life.esp") as quest
	if(chargenquest.GetStage() < 20)
		objectreference MaraStatue = Game.GetFormFromFile(0x1386B8, "Alternate Start - Live Another Life.esp") as ObjectReference
		if(StatueOfMara.GetReference() == MaraStatue)
			;debug.trace("Alias already holds the Mara statue.")
			SSODialogue.Start()
		elseif(MaraStatue != none)
			StatueOfMara.ForceRefIfEmpty(MaraStatue)
			debug.trace("Setting alias to Mara statue.")
			SSODialogue.Start()
		else
			debug.trace("Couldn't find the Mara statue to fill alias!")
		endif
        SSOChildFound.SetValue(IsChildRace(game.getplayer().getrace()))
		registerforsingleupdate(1.0)
	else
		unregisterforupdate()
	endif
EndEvent